<?php

error_reporting(E_ALL);

require_once 'settings.php';
require_once 'CSE_display/CSE_display.php';

session_start();

function cleaninput($in, $type="text") {
	switch ($type) {
		case "none":
			// use with care!
			$out = $in;
			break;
		case "int":
			$out = intval($in);
			break;
		case "num":
			$out = floatval($in);
			break;
		case "html":
			$out = htmlspecialchars($in);
			break;
		case "text":
			$out = htmlspecialchars(strip_tags(trim($in)));
			break;
		case "sql":
			$out = mysql_real_escape_string(addslashes(htmlspecialchars(strip_tags(trim($in)))));
			break;
		case "cmd":
			$out = escapeshellcmd($in);
			break;
		case "arg":
			$out = escapeshellarg($in);
			break;
		default:
			$out = addslashes(htmlspecialchars(strip_tags(trim($in))));
	}
	return $out;
}

function browsedir($lan, $locdir, $baseurl, $showfiles, $fld_list, $indent=0, $rights=0) {
	$bufer = "";
	$buffer2 = "";
	$all = opendir($locdir);
	while ($file = readdir($all)) {
		$trc .= "<br>File: ".$file;
		if ($file <> ".." and $file <> ".") {
			if (is_dir($locdir."/".$file)) {
				$trgt = "ok";
				if ($rights>=0 and file_exists($locdir."/".$file."/CSE_lock")) {
					$content = file_get_contents($locdir."/".$file."/CSE_lock");
					if (strstr($content, $rights) === false) {
						$trgt = "CSE_null";
					}
				}
				if ($file == "tn") {
					$trgt = "CSE_null";
				}
				if ($trgt == "ok") {
					$buffer .= "&#187; <span class=toc_folder><a href='".$baseurl.$file."/'>".(str_replace("_", " ", $file))."</a></span><br>\n";
					$tmp = array_search($file, $fld_list);
					if ($tmp!==false) {
						if ($tmp==count($fld_list)-1) {
							if (file_exists($locdir."/".$file."/CSE_Gallery.txt")) {
								$buffer .= "<div class=toc_indent_".$indent.">".browsedir($lan, $locdir."/".$file, $baseurl.$file."/", false, $fld_list, $indent+1, $rights)."</div>";
							} else {
								$buffer .= "<div class=toc_indent_".$indent.">".browsedir($lan, $locdir."/".$file, $baseurl.$file."/", true, $fld_list, $indent+1, $rights)."</div>";
							}
						} else {
							$buffer .= "<div class=toc_indent_".$indent.">".browsedir($lan, $locdir."/".$file, $baseurl.$file."/", false, $fld_list, $indent+1, $rights)."</div>";
						}
					}
				}
			} else {
				if ($showfiles) {
					// should not begin with .
					if (strpos($file, ".")!==0 and $file != "CSE_lock" and $file != "CSE_Gallery.txt" and $file != "CSE_translate" and $file != "CSE_content" and $file != "CSE_hot") {
						// remove filetype, if any
						if (strpos($file, ".link")) {
							$master_url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
							$lk_tp = $master_url."/".file_get_contents($locdir."/".$file);
							$nb = preg_match("/(.*)\.(.{2,5})$/",$file,$matches);
							if ($nb==1) {
								$file = $matches[1];
							}
							// recover "spaces" from underscores:
							$file_name = str_replace("_", " ", $file);
							$buffer2 .= "&#187; <span class=toc_file><a href='".$lk_tp."/'><i>".$file_name."</i></a></span><br>\n";
						} elseif (strpos($file, ".plug")) {
							$master_url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
							$lk_tp = $master_url."/".file_get_contents($locdir."/".$file);
							$nb = preg_match("/(.*)\.(.{2,5})$/",$file,$matches);
							if ($nb==1) {
								$file = $matches[1];
							}
							// recover "spaces" from underscores:
							$file_name = str_replace("_", " ", $file);
							$it_link = file_get_contents($locdir."/".$file.".plug");
							$content_opt = str_replace("\n", "", $it_link);
							parse_str($content_opt, $myContent);
							$buffer2 .= "&#187; <span class=toc_file><a href='".$master_url."/".$lan."/CSE_plugin?name=".$myContent['name']."'>".$file_name."</a></span><br>\n";
						} else {
							if (strpos($file, ".embed")) {
								$file_name = str_replace("_", " ", $file);
								$nb = preg_match("/(.*)\.(.{2,5})$/",$file_name,$matches);
								if ($nb==1) {
									$file_name = $matches[1];
								}
								$buffer2 .= "&#187; <span class=toc_file><a href='".$baseurl.$file."/'><i>".$file_name."</i></a></span><br>\n";
							} elseif (strpos($file, ".exbed")) {
								$file_name = str_replace("_", " ", $file);
								$nb = preg_match("/(.*)\.(.{2,5})$/",$file_name,$matches);
								if ($nb==1) {
									$file_name = $matches[1];
								}
								$buffer2 .= "&#187; <span class=toc_file><a href='".$baseurl.$file."/'><i>".$file_name."</i></a></span><br>\n";
							} elseif (strpos($file, ".ajax")) {
								$file_name = str_replace("_", " ", $file);
								$nb = preg_match("/(.*)\.(.{2,5})$/",$file_name,$matches);
								if ($nb==1) {
									$file_name = $matches[1];
								}
								$buffer2 .= "&#187; <span class=toc_file><a href='".$baseurl.$file."/'>".$file_name."</a></span><br>\n";
							} else {
								$nb = preg_match("/(.*)\.(.{2,5})$/",$file,$matches);
								if ($nb==1) {
									$file = $matches[1];
								}
								// recover "spaces" from underscores:
								$file_name = str_replace("_", " ", $file);
								$buffer2 .= "&#187; <span class=toc_file><a href='".$baseurl.$file."/'>".$file_name."</a></span><br>\n";
							}
						}
					}
				}
			}
		}
	}
	return $buffer.$buffer2;
}

function makeIndex($dir, $indx_nme = ".CSE_Index") {
	$buffer = "";
	

}

function makeTOC($myHTML, $CSE_TOC_NAME, $lan, $fld_list, $rights) {
	global $CSE_HOME;

	$id = $myHTML->addPanel("TOC");
	$myHTML->IP_setTitle($id,$CSE_TOC_NAME);
	
	$baseurl = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/";
	$locdir = dirname(__FILE__)."/".$lan;
	$buffer = "&#187; <span class=toc_folder><a href='".$baseurl."'>".$CSE_HOME[$lan]."</a></span><br>\n<div class=toc_base_indent>";
	$buffer .= browsedir($lan, $locdir, $baseurl, false, $fld_list, 1, $rights)."</div>";
	$myHTML->IP_appendBody($id, $buffer);
	
}

function makeCatTOC($myHTML, $CSE_CATTOC_NAME, $dir, $parenturl) {

	$id = $myHTML->addPanel("catTOC");
	$nb = preg_match("@(.*)/([^/]*)$@",$dir,$matches);
	if ($nb==1) {
		$title = $matches[2];
	}
	$myHTML->IP_setTitle($id,$title);
	
	$baseurl = $parenturl."/";
	$locdir = $parentdir;
	$fld_list[] = "";
	$buffer = browsedir($lan, $dir, $baseurl, true, $fld_list);
	$myHTML->IP_appendBody($id, $buffer);
	
}

function searchdir($dir, $url, $includefiles, $query_string, &$buffer_dir, &$buffer_filename, &$buffer_content, $rights) {
	$all = opendir($dir);
	while ($file = readdir($all)) {
		if ($file <> ".." and $file <> ".") {
			if (is_dir($dir."/".$file)) {
				$goon = true;
				if ($rights>=0 and file_exists($dir."/".$file."/CSE_lock")) {
					$content = file_get_contents($dir."/".$file."/CSE_lock");
					if (strstr($content, $rights) === false) {
						$goon = false;
					}
				}
				if ($goon) {
					$file_name = str_replace("_", " ", $file);
					if (preg_match("/".$query_string."/i",$file)) {
						$buffer_dir .= "&#187; <span class=toc_file><a href='".$url."/".$file."/'>".$file_name."</a></span> <span class=file_ext>(".$url."/".$file.")</span><br>\n";
					}
					searchdir($dir."/".$file, $url."/".$file, $includefiles, $query_string, $buffer_dir, $buffer_filename, $buffer_content, $rights);
				}
			} else {
				if (strpos($file, ".")!==0 and $file<>"CSE_lock" and $file<>"CSE_Gallery.txt" and $file != "CSE_translate") {
					// recover "spaces" from underscores:
					$file_name = str_replace("_", " ", $file);
					if (preg_match("/".$query_string."/i",$file)) {
						if (preg_match("/\.(jpg|gif|png|jpeg)$/i",$file)) {
							;//$buffer_filename .= "&#187; <span class=toc_file><a href=".$url."/>".$file_name."</a></span> <span class=file_ext>(".$url."/".$file.")</span><br>\n";
						} else {
							$content = file_get_contents($dir."/".$file, 0, null, 0, 80);
							$buffer_filename .= "&#187; <span class=toc_file><a href='".$url."/".$file."/'>".$file_name."</a></span> <span class=file_ext>(".$url."/".$file.")</span><br><span class=file_ext>".$content."...</span><br>\n";
						}
					} else {
						if ($includefiles) {
							// read file
							$content = file_get_contents($dir."/".$file);
							$nb = preg_match("/(.{0,40})(".$query_string.")(.{0,40})/i",$content,$matches);
							if ($nb==1) {
								$buffer_content .= "&#187; <span class=toc_file><a href='".$url."/".$file."/'>".$file_name."</a></span> <span class=file_ext>(".$url."/".$file.")</span><br><span class=file_ext>...".(strip_tags($matches[1],'<p><a>'))."</span><span class=search_highlight>".$matches[2]."</span><span class=file_ext>".(strip_tags($matches[3],'<p><a>'))."...</span><br>\n";
							}
						}
					}
				}
			}
		}
	}
}

function search_site($url, $dir, $query_string, $query_lan, $lan, $query_cont, $CSE_SEARCH, $CSE_WITHCONTENT, $CSE_NOHITS, $CSE_HITSTYPE, $CSE_LANG, $rights) {
	$buffer_dir = "";
	$buffer_filename = "";
	$buffer_content = "";
	$sdir = $dir;
	$surl = $url;
	if ($query_lan != "all") {
		$sdir .= "/".$query_lan;
		$surl .= "/".$query_lan;
		searchdir($sdir, $surl, $query_cont, stripslashes($query_string), $buffer_dir, $buffer_filename, $buffer_content, $rights);
	} else {
		foreach ($CSE_LANG as $lan_dir => $lan_name) {
			$sdir = $dir."/".$lan_dir;
			$surl = $url."/".$lan_dir;
			searchdir($sdir, $surl, $query_cont, stripslashes($query_string), $buffer_dir, $buffer_filename, $buffer_content, $rights);
		}
	}
	
	if ($buffer_dir == "" and $buffer_filename == "" and $buffer_content == "") {
		$buffer_dir = $CSE_NOHITS[$lan];
	} else {
		if ($buffer_dir != "") {
			$buffer_dir = "<b>".$CSE_HITSTYPE["folder"][$lan]."</b>:<br>" . $buffer_dir . "<br><br>";
		}
		if ($buffer_filename != "" or $buffer_content != "") {
			$buffer_filename = "<b>".$CSE_HITSTYPE["article"][$lan]."</b>:<br>" . $buffer_filename;
		}
	}
	
	if ($query_cont!= 1) {
		$buffer_content .= "<br><br><a href='".$url."/".$lan."/search?lang=".$query_lan."&key=".$query_string."&cont=1'>".$CSE_SEARCH[$lan]."</a> ".$CSE_WITHCONTENT[$lan]."<br>";
	}
	
	$buffer = $buffer_dir.$buffer_filename.$buffer_content;
	return $buffer;
}

function makeSearch($myHTML, $CSE_SEARCH, $CSE_IN_LANG, $CSE_WHOLE_SITE, $lan) {
	//$id = $myHTML->addPanel("searchP");
	//$myHTML->IP_setTitle($id,$CSE_SEARCH[$lan]);
	//$search_box = "<table width=100%><tr><td class=search_form><form id=search_form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/search' method=GET>";
	//$search_box .= "<input type=radio value=".$lan." id=lang name=lang checked>".$CSE_IN_LANG[$lan]."<br><input type=radio value='all' id=lang name=lang>";
	//$search_box .= $CSE_WHOLE_SITE[$lan]."</td><td><input class=inputbox type=text size=15 name=key value=''><input type=hidden name=cont value=0></td>";
	//$search_box .= "<td class=search_button><a href='javascript:search_form.submit()' onclick='javascript:search_form.submit()'>&#187;</a></td></tr></table></form>";
	//$myHTML->IP_appendBody($id, $search_box);
	$search_box = "<span class=title_silver>".$CSE_SEARCH[$lan]."</span><form id=search_form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/search' method=GET>";
	$search_box .= "<input type=radio value=".$lan." id=lang name=lang checked>".$CSE_IN_LANG[$lan]."&nbsp;<input type=radio value='all' id=lang2 name=lang>";
	$search_box .= $CSE_WHOLE_SITE[$lan]."<br><input class=inputbox type=text size=15 name=key value=''><input type=hidden name=cont value=0>";
	$search_box .= "<a href='javascript:search_form.submit()' onclick='javascript:search_form.submit()' class=tree title='".$CSE_SEARCH[$lan]."'>&#187;</a></form>";
	$myHTML->appendRegion('SEARCH',$search_box);
}

function makeAdminPanel($myHTML, $loc, $lan, $CSE_ADMINFOLDER) {
	$id = $myHTML->addPanel("admin");
	$myHTML->IP_setTitle($id, "Administration");
	$loc = str_replace("/", "£", $loc);
// 	$admin_cnt = "<div class=infobox_control><table width=100%><tr><td class=search_form colspan=3>Add in current folder:</td></tr><tr><td class=search_form><form id=add_cat action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_addCat' method=GET>";
// 	$admin_cnt .= "Folder:</td><td><input class=inputbox type=text size=15 name=key value=''><input type=hidden name=loc value=".$loc."></td><td class=search_button>&nbsp;<a href='javascript:add_cat.submit()' onclick='javascript:add_cat.submit()'>&#187;</a></form></td></tr>";
// 	$admin_cnt .= "<tr><td class=search_form><form id=add_file action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_addDoc' method=GET>";
// 	$admin_cnt .= "Document:</td><td><input class=inputbox type=text size=15 name=key value=''><input type=hidden name=loc value=".$loc."></td><td class=search_button>&nbsp;<a href='javascript:add_file.submit()' onclick='javascript:add_file.submit()'>&#187;</a></form></td></tr>";
// 	$admin_cnt .= "<tr><td class=search_form><form enctype='multipart/form-data' id=upload_data action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_uploadData/' method=POST>Upload:</td><td class=search_form><input type='hidden' name='MAX_FILE_SIZE' value='300000'>";
// 	$admin_cnt .= "<input type=radio name=is_data value='yes' checked>Media&nbsp;<input type=radio name=is_data value='no'>Doc<input type=hidden name=loc value=".$loc."></td><td class=search_button valign=center>&nbsp;<a href='javascript:upload_data.submit()' onclick='javascript:upload_data.submit()'>&#187;</a></td></tr></table>";
// 	$admin_cnt .= "<input name='upfile' type='file'></form>";
// 	$admin_cnt .= "</div>";

	$admin_cnt = "<span class=toc_file>";
	// get elements in the administration folder
	$admin_fld = dirname(__FILE__)."/".$CSE_ADMINFOLDER."/";
	$all = opendir($admin_fld);
	while ($file = readdir($all)) {
		if (($file!=".") and ($file!="..") ) {
			if (is_dir($admin_fld.$file)) {
			
			} else {
				$file = substr($file, 0, max(strlen($file)-4,0));
				$admin_cnt .= "&#187; <a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_admin?name=".$file."'>".$file."</a><br>\n";
			}
		}
	}
	$admin_cnt .= "</span>";
	$myHTML->IP_appendBody($id, $admin_cnt);
}

function makeHotLinks($myHTML, $CSE_HOT, $lan, $master_url) {
	// search for hot links:
	if (file_exists(dirname(__FILE__)."/".$lan."/CSE_hot")) {
		$id = $myHTML->addPanel("admin");
		$myHTML->IP_setTitle($id, $CSE_HOT[$lan]);
		$content = file_get_contents(dirname(__FILE__)."/".$lan."/CSE_hot");
		$mylinks = explode("\n",$content);
		$hots = "";
		foreach ($mylinks as $lk) {
			if ($lk != "") {
				$mynames = explode("/", $lk);
				$nme = end($mynames);
				if ($nme == "") { $nme = prev($mynames); }
				$nme = str_replace("_", " ", $nme);
				$nb = preg_match("/(.*)\.(.{2,5})$/",$nme,$matches);
				if ($nb==1) {
					$nme = $matches[1];
				}
				$hots .= "&#187; <span class=toc_file><a href='".$master_url."/".$lan."/".$lk."'>".$nme."</a></span><br>";
			}
		}
		$myHTML->IP_appendBody($id, $hots);
	}
}

function makecomments($lan, $CSE_COMMENTS_INTRO) {
	$str = "";
	// analyse form
	if (isset($_POST["CSE_com_name"])) {
		if (cleaninput($_POST["CSE_com_valid"])==cleaninput($_POST["CSE_com_key"])) {
			$newcomment = "<span class=comment><b>".(cleaninput($_POST["CSE_com_name"]))."</b>, <i>".date("d.m.Y")."</i><br>";
			$newcomment .= "&nbsp;&nbsp;&nbsp;".(cleaninput($_POST["CSE_com_com"]))."</span><br>";
			$str .= "Thanks for submitting a comment!<br><br>".$newcomment."<br><hr>";
			if (file_exists(dirname(__FILE__)."/stats/CSE_commentaires")) {
				$newcomment = $newcomment."\n".file_get_contents(dirname(__FILE__)."/stats/CSE_commentaires");
			}
			$ok = file_put_contents(dirname(__FILE__)."/stats/CSE_commentaires", $newcomment, LOCK_EX);
		} else {
			$str .= "You may want to use a calculator for the anti-spam question! Click back to retry...<br><hr>";
		}
	} else {
		$str .= $CSE_COMMENTS_INTRO[$lan]."<br><hr>";
		// display form
		$str .= "<form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_comment?act=do' method=POST>";
		$str .= "<table class=comment_form><tr><td colspan=2>Name:<input type=text value='anonymous' name=CSE_com_name></td>";
		$str .= "<td>Comment:</td><td><textarea name=CSE_com_com rows=2 cols=40>Type your comment here.</textarea></td></tr>";
		srand(time());
		$nb = (rand()%98);
		$str .= "<tr><td>Anti-spam question:</td><td>".$nb."+1=<input type=text size=4 value='' name=CSE_com_valid>&nbsp;&nbsp;&nbsp;";
		$str .= "<input type=hidden value=".($nb+1)." name=CSE_com_key></td><td colspan=2>";
		$str .= "<input type=submit value='Submit Comment' name=submit></td></tr></table>";
		$str .= "</form><hr>";
	}
	// display comments
	if (file_exists(dirname(__FILE__)."/stats/CSE_commentaires")) {
		$str .= file_get_contents(dirname(__FILE__)."/stats/CSE_commentaires");
	} else {
		$str .= "<br><br><i>Be the first to comment!</i><br>";
	}
	return $str;
}

function makecontact($lan, $CSE_CONTACTS, $CSE_EMAIL, $CSE_ADDRESS) {
	$str = "";
	// analyse form
	if (isset($_GET["CSE_msg_name"])) {
		if (cleaninput($_GET["CSE_msg_valid"])==cleaninput($_GET["CSE_msg_key"])) {
			$str .= $CSE_CONTACTS["thanks"][$lan];
			$to = $CSE_EMAIL;
			$headers = "From: auto_contact@".$_SERVER['SERVER_NAME']."\r\nReply-To: ".(cleaninput($_GET["CSE_msg_email"]))."\r\nX-Mailer: PHP/".phpversion();
			$subject = "Comment from cavin.name";
			$message = wordwrap(cleaninput($_GET["CSE_msg_com"]));
			$str .= "<br><br>TO: <i>cavin.name</i> FROM: <i>".(cleaninput($_GET["CSE_msg_name"]))." &lt;".(cleaninput($_GET["CSE_msg_email"]))."&gt;</i><br>";
			$str .= str_replace("\n", "<br>", $message);
			$message = "FROM: ".(cleaninput($_GET["CSE_msg_name"]))." <".(cleaninput($_GET["CSE_msg_email"])).">\n\n".$message;
			mail($to, $subject, $message, $headers);
		} else {
			$str .= "You may want to use a calculator for the anti-spam question! Click back to retry...<br>";
		}
	} else {
		$str .= $CSE_CONTACTS["intro"][$lan];
		// display form
		$str .= "<form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_contact' method=GET>";
		$str .= "<table class=comment_form><tr><td>".$CSE_CONTACTS["from"][$lan].":</td><td><input type=text value='anonymous' name=CSE_msg_name></td></tr>";
		$str .= "<tr><td>".$CSE_CONTACTS["email"][$lan]."*:</td><td><input type=text value='' size=30 name=CSE_msg_email></td></tr>";
		$str .= "<td valign=top>".$CSE_CONTACTS["msg"][$lan].":</td><td><textarea name=CSE_msg_com rows=5 cols=50>Type your comment here.</textarea></td></tr>";
		srand(time());
		$nb = (rand()%98);
		$str .= "<tr><td>".$CSE_CONTACTS["nospam"][$lan].":</td><td>".$nb."+1=<input type=text size=4 value='' name=CSE_msg_valid>&nbsp;&nbsp;&nbsp;";
		$str .= "<input type=hidden value=".($nb+1)." name=CSE_msg_key>";
		$str .= "<input type=submit value='Submit' name=submit></td></tr>";
		$str .= "<tr><td colspan=2><font size=-1>*) ".$CSE_CONTACTS["email_info"][$lan]."</font></table>";
		$str .= "</form>";
	}
	$str .= "<br><br><hr><br>".$CSE_ADDRESS;
	
	return $str;
}

function makeContacts($myHTML, $CSE_CONTACTS, $CSE_COMMENTS, $lan, $master_url) {
	// search for hot links:
	$id = $myHTML->addPanel("contact");
	$myHTML->IP_setTitle($id, $CSE_CONTACTS["title"][$lan]);

	$myHTML->IP_appendBody($id, "&#187; <span class=toc_file><a href='".$master_url."/".$lan."/CSE_comment/'>".$CSE_COMMENTS[$lan]."</a></span><br>");
	$myHTML->IP_appendBody($id, "&#187; <span class=toc_file><a href='".$master_url."/".$lan."/CSE_contact/'>".$CSE_CONTACTS["contact"][$lan]."</a></span>");
}

function take_body($content) {
	// if we get an html file, then strip all but body.
	
	
	// string strip_tags ( string $str [, string $allowable_tags ] )
	// echo strip_tags($text, '<p><a>');
	return $body;
}

function userPanel($myHTML, $CSE_USER_TEXTS, $lan, $CSE_USERLIST, $quitting) {
	// get actual rights
	$rights = 0;
	if ($quitting || empty($_SESSION['CSE_CMS_Identity'])) {
		// session does not exist
		if (empty($_POST['login'])) {
			// and nobody tried to register
			// we keep it like this...
		} else {
			// somebody trying to register?
			$name = cleaninput($_POST['login']);
			$pass = cleaninput($_POST['passw']);
			// validate this guy:
			//$myHTML->AppendBody("/".$name." ".$pass." ([]*)/i<br>", 1);
			$content = file_get_contents(dirname(__FILE__)."/".$CSE_USERLIST);
			$nb = preg_match("/".$name." ".$pass." ([^\s]*)/i",$content,$matches);
			if ($nb==1) {
				$rights = $matches[1];
				$_SESSION['CSE_CMS_Identity'] = $rights;
				$_SESSION['CSE_CMS_Name'] = $name;
			}
			//$myHTML->AppendBody($content, 1);
		}
	} else {
		$rights = $_SESSION['CSE_CMS_Identity'];
		$name = $_SESSION['CSE_CMS_Name'];
	}
	
	// print pannel
	$id = $myHTML->addPanel("userP");
	$myHTML->IP_setTitle($id,$CSE_USER_TEXTS["user"][$lan]);
	// introduce choice of site template.
	$user_box = $CSE_USER_TEXTS["template"][$lan].": <span class=toc_file><a href=http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_template?name=0>Normal</a></span> | <span class=toc_file><a href=http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_template?name=1>Alternate</a></span><br>";
	// the real user management
	if ($rights == -1) {
		$user_box .= "Logged as <b>".$name."</b>&nbsp;[<a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_logoff/'>".$CSE_USER_TEXTS["logoff"][$lan]."</a>]<br>".$CSE_USER_TEXTS["admin"][$lan];
	} elseif ($rights > 0) {
		$user_box .= "Logged as <b>".$name."</b>&nbsp;[<a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_logoff/'>".$CSE_USER_TEXTS["logoff"][$lan]."</a>]<br>".$CSE_USER_TEXTS["registered"][$lan];
	} else {
		$user_box .= "<table width='100%'><tr><td class=user_form><form id=register_form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_login?act=do' method=POST>";
		$user_box .= $CSE_USER_TEXTS["login"][$lan].": <br>".$CSE_USER_TEXTS["pass"][$lan].": </td><td><input class=inputbox type=text size=15 name=login value=''><br>";
		$user_box .= "<input class=inputbox type=password size=15 name=passw value=''></td>";
		$user_box .= "<td class=search_button><a href='javascript:register_form.submit()' onclick='javascript:register_form.submit()'>&gt;&gt;</a></td></tr>";
		$user_box .= "<tr><td colspan=3><span class=file_ext>".$CSE_USER_TEXTS["register"][$lan]."</span></td></tr></table></form>";
	}
	$myHTML->IP_appendBody($id, $user_box);
	$myHTML->infopanels[$id]->defaultpositionInfoPanel("mini");
	return $rights;
}

function displayfolder($lan, $dir, $url, $title, $CSE_LANG) {
	if (file_exists($dir."/CSE_Gallery.txt")) {
		$subcnt = $CSE_Gallery_Category[$lan]."<br>";
		// try to find a thumbnail
		if (file_exists($dir."/tn/")) {
			if (is_dir($dir."/tn/")) {
				$suball = opendir($dir."/tn/");
				$over = 0;
				while ($subfile = readdir($suball) and $over<2) {
					if (stripos($subfile, ".png") or stripos($subfile, ".jpg") or stripos($subfile, ".gif") or stripos($subfile, ".jpeg")) {
						$over++;
						$subcnt .= "<img alt='thumbnail' src='".$url."/tn/".$subfile."'>";
					}
				}
			}
		}
		$subcnt .= "...";
		return $title."<table><tr><td valign=top><a href=".$url."><img src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/folder_icon.png' alt='folder'></a></td><td valign=top>".$subcnt."</td></tr></table>";
	} else {
		$suball = opendir($dir);
		$subcnt = "";
		$subnb = 0;
		while ($subfile = readdir($suball) and $subnb < 6) {
			if ($subnb < 5) {
				if ($subfile <> ".." and $subfile <> "." and $subfile <> "CSE_hot" and (strpos($subfile, ".")!==0) and $subfile<>"CSE_lock" and $subfile<>"CSE_gallery.txt" and $subfile<>"CSE_translate" and $subfile<>"CSE_content") {
					if (is_dir($dir."/".$subfile)) {
						$subcnt .= "&nbsp;&nbsp;&#187;&nbsp;<span class=blog_links><b><a href='".$url."/".$subfile."'>".str_replace("_", " ", $subfile)."</a></b></span><br>";
					} else {
						if (strpos($subfile, ".link")) {
							$master_url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
							$lk_tp = file_get_contents($dir."/".$subfile);
							// does the link go to another language?
							$nb = preg_match("/^(..)\/.*$/",$lk_tp,$matches);
							if ($nb==1) {
								$new_lan = $matches[1];
								if ($new_lan == $lan) {
									$new_lan = "";
								} else {
									$new_lan = "<img title='".$CSE_LANG[$new_lan]."' alt='".$CSE_LANG[$new_lan]."' src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/".$new_lan.".gif' width=16>";
								}
							} else {
								$new_lan = "";
							}
							$lk_tp = $master_url."/".$lk_tp;
							$nb = preg_match("/(.*)\.(.{2,5})$/",$subfile,$matches);
							if ($nb==1) {
								$subfile = $matches[1];
							}
							$subcnt .= "&nbsp;&nbsp;&#187;&nbsp;<span class=blog_links><a href='".$lk_tp."'>".str_replace("_", " ", $subfile)."</a> ".$new_lan."</span><br>";
						} elseif (strpos($subfile, ".plug")) {
							$master_url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
							$lk_tp = $master_url."/".file_get_contents($dir."/".$subfile);
							$nb = preg_match("/(.*)\.(.{2,5})$/",$subfile,$matches);
							if ($nb==1) {
								$subfile = $matches[1];
							}
							$file_name = str_replace("_", " ", $subfile);
							$it_link = file_get_contents($dir."/".$subfile.".plug");
							$content_opt = str_replace("\n", "", $it_link);
							parse_str($content_opt, $myContent);
							$subcnt .= "&nbsp;&nbsp;&#187;&nbsp;<span class=blog_links><a href='".$master_url."/".$lan."/CSE_plugin?name=".$myContent['name']."'>".$file_name."</a></span><br>";
						} else {
							$nb = preg_match("/(.*)\.(.{2,5})$/",$subfile,$matches);
							if ($nb==1) {
								$file_name = $matches[1];
							} else {
								$file_name = $subfile;
							}
							$file_name = str_replace("_", " ", $file_name);
							$subcnt .= "&nbsp;&nbsp;&#187;&nbsp;<span class=blog_links><a href='".$url."/".$subfile."'>".$file_name."</a></span><br>";
						}
					}
					$subnb++;
				}
			} else {
				$subcnt .= "&nbsp;&nbsp;&#187;&nbsp;...";
				$subnb++;
			}
		}
		return $title."<table><tr><td valign=top><a href='".$url."'><img src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/folder_icon.png' alt='folder'></a></td><td valign=top>".$subcnt."</td></tr></table>";
	}
}

function updateStats($myHTML,$CSE_STATS,$lan) {
	$st_file = dirname(__FILE__)."/stats/CSE_stats";
// 	unlink($st_file);
// 	return;
	$msg = "";
	// past situation
	if (file_exists($st_file)) {
		$st_str = file_get_contents($st_file);
		$st_str = str_replace("\n", "", $st_str);
		parse_str($st_str, $myStats);
	} else {
		$myStats["Start"] = date("d.m.Y");
		$myStats["Hits"] = 0;
		$myStats["Unique"] = 0;
		$myStats["BotUnique"] = 0;
		$myStats["Chrome"] = 0;
		$myStats["Safari"] = 0;
		$myStats["MSIE"] = 0;
		$myStats["Firefox"] = 0;
		$myStats["Opera"] = 0;
		$myStats["Bot"] = 0;
		$myStats["Mac"] = 0;
		$myStats["Win"] = 0;
		$myStats["Linux"] = 0;
		$myStats["NA"] = 0;
	}
	// get some info on requestor
	$brow_nb = 0;
	$agent_stat = "\nVisitor statistics:\n-------------------\n";
	$agent = $_SERVER['HTTP_USER_AGENT'];
	if (strpos($agent, "Chrome")!==false) {
		// chrome must be before safari as it uses safari under the hood.
		$browser = "Chrome";
		$myStats["Chrome"]++;
	} elseif (strpos($agent, "Safari")!==false) {
		$browser = "Safari";
		$myStats["Safari"]++;
	} elseif (strpos($agent, "Opera")!==false) {
		// opera must be before Firefox and IE
		$browser = "Opera";
		$myStats["Opera"]++;
	} elseif (strpos($agent, "MSIE")!==false) {
		$browser = "MSIE";
		$myStats["MSIE"]++;
	} elseif (strpos($agent, "Firefox")!==false) {
		$browser = "Firefox";
		$myStats["Firefox"]++;
	} else {
		$browser = "Bot";
		$myStats["Bot"]++;
	}
	$brow_nb = $brow_nb + $myStats["Chrome"];
	$brow_nb = $brow_nb + $myStats["Safari"];
	$brow_nb = $brow_nb + $myStats["MSIE"];
	$brow_nb = $brow_nb + $myStats["Firefox"];
	$brow_nb = $brow_nb + $myStats["Opera"];
	$agent_stat .= "Safari: ".round($myStats["Safari"]/$brow_nb*100)."%\n";
	$agent_stat .= "MSIE: ".round($myStats["MSIE"]/$brow_nb*100)."%\n";
	$agent_stat .= "Chrome: ".round($myStats["Chrome"]/$brow_nb*100)."%\n";
	$agent_stat .= "Firefox: ".round($myStats["Firefox"]/$brow_nb*100)."%\n";
	$agent_stat .= "Opera: ".round($myStats["Opera"]/$brow_nb*100)."%\n";
	$os_nb = 0;
	if (strpos($agent, "Mac OS X") or strpos($agent, "Macintosh")) {
		$os = "Mac";
		$myStats["Mac"]++;
	} elseif (strpos($agent, "Windows")) {
		$os = "Win";
		$myStats["Win"]++;
	} elseif (strpos($agent, "Linux") or strpos($agent, "Unix")) {
		$os = "Linux";
		$myStats["Linux"]++;
	} else {
		$os = "NA";
		$myStats["NA"]++;
	}
	$os_nb = $os_nb + $myStats["Mac"];
	$os_nb = $os_nb + $myStats["Win"];
	$os_nb = $os_nb + $myStats["Linux"];
	$agent_stat .= "\nMac: ".round($myStats["Mac"]/$os_nb*100)."%\n";
	$agent_stat .= "Win: ".round($myStats["Win"]/$os_nb*100)."%\n";
	$agent_stat .= "Linux: ".round($myStats["Linux"]/$os_nb*100)."%\n";
	// update
	$myStats["Hits"]++;
	if (isset($_COOKIE["CSE_CMS_stats_visits"])) {
		$visits = cleaninput($_COOKIE["CSE_CMS_stats_visits"],"int")+1;
	} else {
		if ($browser == "Bot") {
			$myStats["BotUnique"]++;
		} else {
			$myStats["Unique"] = $myStats["Unique"]+1;
		}
		$visits = 1;
	}
	setcookie("CSE_CMS_stats_visits", $visits, time()+60*60, "/");
//  reset
//	-----
// 	$myStats["Hits"] = 0;
// 	$myStats["Unique"] = 0;
// 	setcookie("CSE_CMS_stats_visits", $visits, time()-10, "/");
	// output
	$id = $myHTML->addPanel("stats");
	$myHTML->IP_setTitle($id,$CSE_STATS["title"][$lan]);
	$myHTML->IP_appendBody($id, "&#187; <span title='Unique page requests since ".$myStats["Start"]."' style='cursor: help'>".$CSE_STATS["hits"][$lan].$myStats["Hits"]."</span><br>");
	$myHTML->IP_appendBody($id, "&#187; <span title='All page requests for one user are counted together, assuming he supports cookies. A new visit begins however after 60min without page request. Requests from unknown browser are not counted, which makes of this number an underestimate - some human visitor may be considered to be bots. Visits since ".$myStats["Start"]."' style='cursor: help'>".$CSE_STATS["unique"][$lan].$myStats["Unique"]." (".(round(($myStats["Hits"]-$myStats["BotUnique"])/$myStats["Unique"]*10)/10)." ".$CSE_STATS["hitspervisit"][$lan].")</span><br>");
	$myHTML->IP_appendBody($id, "&#187; <span title='All page requests from an unknown user-agent (i.e. not a browser from the following: Safari, Firefox, Internet Explorer, Opera, Chrome) are deemed to be bots, such as google bot that index a page. This is an overestimate, i.e. human reader may be counted here. Such requests are counted here since ".$myStats["Start"].".' style='cursor: help'>".$CSE_STATS["bots"][$lan].$myStats["BotUnique"]." (".$CSE_STATS["hits"][$lan].(round(($myStats["BotUnique"]/$myStats["Hits"])*1000)/10)."%)</span><br>");
	$myHTML->IP_appendBody($id, "&#187; <span title='Page requests in the current visit.\n".$CSE_STATS["agent"][$lan].$browser." (".$os.").\n".$agent_stat."' style='cursor: help'>".$CSE_STATS["you"][$lan].$visits."</span><br>");
	//$myHTML->IP_appendBody($id, "&#187; <span title='".."' style='cursor: help'>".$CSE_STATS["agent"][$lan].$browser." (".$os.")</span>");
	// write file
	$st_str = "";
	foreach ($myStats as $key => $value) {
		$st_str .= "&".$key."=".$value;
	}
	$st_str = substr($st_str,1);
	file_put_contents($st_file, $st_str, LOCK_EX);
}

// create display object
$url = "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']);
$master_url = $url;
$template = "_CMS";
if (isset($_COOKIE["CSE_CMS_template"])) {
	if (cleaninput($_COOKIE["CSE_CMS_template"], "int")>0) {
		$template .= cleaninput($_COOKIE["CSE_CMS_template"], "int");
		setcookie("CSE_CMS_template", cleaninput($_GET['name'], "int"), time()+60*60*24*30, "/");
	}
}
$myHTML = new CSE_display($url."/CSE_display/CSE_CSS".$template.".css", $url."/CSE_display/CSE_template".$template.".txt");

// sanitization of the input data
// conducted on each call...

// get language
$lan = cleaninput($_GET["lan"]);
if ($lan == "CSE_none") { $lan = $CSE_DEFAULT_LAN; }

// get user rights
// is it loggin-off?
if (cleaninput($_GET["CSE1"]) == "CSE_logoff") {
	if (isset($_COOKIE[session_name()])) {
		setcookie(session_name(), '', time()-42000, '/');
	}
	//unset($_SESSION['CSE_CMS_Identity']);
	session_destroy();
	//$myHTML->AppendBody("session gone", 1);
	$quitting = true;
} else {
	$quitting = false;
}
$rights = userPanel($myHTML, $CSE_USER_TEXTS, $lan, $CSE_USERLIST, $quitting);

// read location
$url = $url."/".$lan;
$dir = dirname(__FILE__)."/".$lan;
$parenturl = $url;
$parentdir = $dir;
$trgt = "";
$edit_url = "";
$parent_edit_url = "";
$edit_base_url = $url."/CSE_edit?src=";
$delete_base_url = $url."/CSE_delete?src=";
$path_string = "<a class=tree href='".$url."/'>".$CSE_HOME[$lan]."</a>";
$lvl1 = cleaninput($_GET["CSE1"]);
if ($lvl1 != "CSE_none") {
	if ($lvl1 == "search") {
		$trgt = "search";
	} elseif ($lvl1 == "CSE_admin") {
		$trgt = "CSE_admin";
	} elseif ($lvl1 == "CSE_comment") {
		$trgt = "CSE_comment";
	} elseif ($lvl1 == "CSE_plugin") {
		$trgt = "CSE_plugin";
	} elseif ($lvl1 == "CSE_template") {
		$trgt = "CSE_template";
	} elseif ($lvl1 == "CSE_contact") {
		$trgt = "CSE_contact";
	} elseif ($lvl1 == "CSE_index") {
		$trgt = "CSE_index";
	} elseif ($lvl1 == "CSE_login") {
		$trgt = "CSE_login";
	} elseif ($lvl1 == "CSE_logoff") {
		$trgt = "CSE_logoff";
	} elseif ($lvl1 == "CSE_edit") {
		$trgt = "CSE_edit";
	} elseif ($lvl1 == "CSE_save") {
		$trgt = "CSE_save";
	} elseif ($lvl1 == "CSE_addCat") {
		$trgt = "CSE_addCat";
	} elseif ($lvl1 == "CSE_addDoc") {
		$trgt = "CSE_addDoc";
	} elseif ($lvl1 == "CSE_delete") {
		$trgt = "CSE_delete";
	} elseif ($lvl1 == "CSE_uploadData") {
		$trgt = "CSE_uploadData";
	} else {
		$parenturl = $url;
		$url .= "/".$lvl1;
		$edit_url .= "£".$lvl1;
		$parentdir = $dir;
		$dir .= "/".$lvl1;
		$tmp_l = str_replace("_", " ", $lvl1);
		$path_string .= "&middot;<a class=tree href='".$url."/'>".$tmp_l."</a>";
		$fld_list[] = $lvl1;
	}
}
$lvl2 = cleaninput($_GET["CSE2"]);
if ($lvl2 != "CSE_none" and !empty($lvl2)) {
	$parenturl = $url;
	$url .= "/".$lvl2;
	$parent_edit_url = $edit_url;
	$edit_url .= "£".$lvl2;
	$parentdir = $dir;
	$dir .= "/".$lvl2;
	$tmp_l = str_replace("_", " ", $lvl2);
	$nb = preg_match("/(.*)\.(.{2,5})$/",$tmp_l,$matches);
	if ($nb==1) {
		$tmp_l = $matches[1];
	}
	$path_string .= "&middot;<a class=tree href='".$url."/'>".$tmp_l."</a>";
	$fld_list[] = $lvl2;
}
$lvl3 = cleaninput($_GET["CSE3"]);
if ($lvl3 != "CSE_none" and !empty($lvl3)) {
	$parenturl = $url;
	$url .= "/".$lvl3;
	$parent_edit_url = $edit_url;
	$edit_url .= "£".$lvl3;
	$parentdir = $dir;
	$dir .= "/".$lvl3;
	$tmp_l = str_replace("_", " ", $lvl3);
	$nb = preg_match("/(.*)\.(.{2,5})$/",$tmp_l,$matches);
	if ($nb==1) {
		$tmp_l = $matches[1];
	}
	$path_string .= "&middot;<a class=tree href='".$url."/'>".$tmp_l."</a>";
	$fld_list[] = $lvl3;
}
$lvl4 = cleaninput($_GET["CSE4"]);
if ($lvl4 != "CSE_none" and !empty($lvl4)) {
	$parenturl = $url;
	$url .= "/".$lvl4;
	$parent_edit_url = $edit_url;
	$edit_url .= "£".$lvl4;
	$parentdir = $dir;
	$dir .= "/".$lvl4;
	$tmp_l = str_replace("_", " ", $lvl4);
	$nb = preg_match("/(.*)\.(.{2,5})$/",$tmp_l,$matches);
	if ($nb==1) {
		$tmp_l = $matches[1];
	}
	$path_string .= "&middot;<a class=tree href='".$url."/'>".$tmp_l."</a>";
	$fld_list[] = $lvl4;
}
$rest = cleaninput($_GET["CSE5"]);
if ($rest != "CSE_none" and !empty($rest)) {
	$parenturl = $url;
	$url .= "/".$rest;
	$parent_edit_url = $edit_url;
	$edit_url .= "£".$rest;
	$parentdir = $dir;
	$dir .= "/".$rest;
	$tmp_l = str_replace("_", " ", $rest);
	$nb = preg_match("/(.*)\.(.{2,5})$/",$tmp_l,$matches);
	if ($nb==1) {
		$tmp_l = $matches[1];
	}
	$path_string .= "&middot;<a class=tree href='".$url."/'>".$tmp_l."</a>";
}

if ($rights<0) {
	if (is_dir($dir)) {
		makeAdminPanel($myHTML, $edit_url, $lan, $CSE_ADMINFOLDER);
	} else {
		makeAdminPanel($myHTML, $parent_edit_url, $lan, $CSE_ADMINFOLDER);
	}
}

$translate_opt = "";
$content_opt = "";
// do we target a special operation?
$extra_title = "";
if ($trgt == "search") {
	// the search program has been called
	$title = $CSE_SEARCH[$lan].": ".(cleaninput($_GET['key']))." (".(cleaninput($_GET['lang'])==all?$CSE_WHOLE_SITE[$lan]:$CSE_IN_LANG[$lan]).")";
	$content = search_site("http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']), dirname(__FILE__), cleaninput($_GET['key']), cleaninput($_GET['lang']), $lan, cleaninput($_GET['cont']), $CSE_SEARCH, $CSE_WITHCONTENT, $CSE_NOHITS, $CSE_HITSTYPE, $CSE_LANG, $rights);
} elseif ($trgt == "CSE_index") {
	// the indexing program has been called
	$title = "Indexing Website - Not Yet Implemented!";
	makeIndex($parentdir, $indx_nme);
} elseif ($trgt == "CSE_comment") {
	$title = $CSE_COMMENTS[$lan];
	$content = makecomments($lan, $CSE_COMMENTS_INTRO);
	$translate_opt = "all: CSE_comment";
} elseif ($trgt == "CSE_admin") {
	$plugin = cleaninput($_GET['name']);
	
	$content = "<iframe name=admin src=http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$CSE_ADMINFOLDER."/".$plugin.".php width=\"100%\" height=\"500\" scrolling=\"auto\" align=\"top\" frameborder=\"0\" class=\"wrapper\"></iframe>";
	
	$title = "Administration: ".$plugin;
	//$content = makecomments($lan, $CSE_COMMENTS_INTRO);
	$translate_opt = "all: CSE_admin?name=".$plugin;
} elseif ($trgt == "CSE_plugin") {
	$plugin = cleaninput($_GET['name']);
	
	require_once(dirname(__FILE__)."/plugin/".$plugin."/index.php");

	$title = call_user_func($plugin."_title", $lan);
	$content = call_user_func($plugin."_content", $lan);
	$translate_opt = "all: CSE_plugin?name=".$plugin;
} elseif ($trgt == "CSE_contact") {
	$title = $CSE_CONTACTS["contact"][$lan];
	$content = makecontact($lan, $CSE_CONTACTS, $CSE_EMAIL, $CSE_ADDRESS);
	$translate_opt = "all: CSE_contact";
} elseif ($trgt == "CSE_login") {
	$name = $_SESSION['CSE_CMS_Name'];
	$extra_title = "Logged as: ".$name;
	$trgt = "";
} elseif ($trgt == "CSE_template") {
	$extra_title = "Selecting other template.";
	$template = "_CMS";
	if (isset($_GET['name'])) {
		if (cleaninput($_GET['name'], "int")>0) {
			$template .= cleaninput($_GET['name'], "int");
		}
		$myHTML->setCSS($master_url."/CSE_display/CSE_CSS".$template.".css");
		$myHTML->setTemplate($master_url."/CSE_display/CSE_template".$template.".txt");
		setcookie("CSE_CMS_template", cleaninput($_GET['name'], "int"), time()+60*60*24*30, "/");
	}
	$trgt = "";
} elseif ($trgt == "CSE_logoff") {
	$extra_title = "De-Registered.";
	$trgt = "";
} elseif ($trgt == "CSE_addCat") {
	$flsrc = str_replace("£","/",cleaninput($_GET['loc']))."/".cleaninput($_GET['key']);
	$title = "Adding ".$flsrc;
	$trgt = "CSE_addCat";
} elseif ($trgt == "CSE_addDoc") {
	$flsrc = str_replace("£","/",cleaninput($_GET['loc']))."/".cleaninput($_GET['key']);
	$title = "Adding ".$flsrc;
	$ed_tit = cleaninput($_GET['key']);
	$trgt = "CSE_edit";
	$ed_cnt = "";
} elseif ($trgt == "CSE_edit") {
	$flsrc = str_replace("£","/",cleaninput($_GET['src']));
	$title = "Editing ".$flsrc;
	$trgt = "CSE_edit";
	$ed_tit = "";
	$ed_cnt = "";
} elseif ($trgt == "CSE_save") {
	$flsrc = str_replace("£","/",cleaninput($_POST['src']));
	$title = "Trying to save: ".$flsrc;
	$trgt = "CSE_save";
} elseif ($trgt == "CSE_uploadData") {
	$flsrc = str_replace("£","/",cleaninput($_POST['loc']))."/";
	if (cleaninput($_POST['is_data']) == "yes") {
		$flsrc = dirname(__FILE__)."/imazes/";
	}
	if ($_FILES['upfile']['error']>0) {
		$title = "There was an error (".$_FILES['upfile']['error'].") when recieving file ".$_FILES['upfile']['name'];
	} else {
		$title = "Trying to upload ".$_FILES['upfile']['name']." to: ".$flsrc;
	}	
	$trgt = "CSE_uploadData";
} elseif ($trgt == "CSE_delete") {
	$flsrc = str_replace("£","/",cleaninput($_GET['src']));
	$title = "Deleting: ".$flsrc;
	$trgt = "CSE_delete";
}
// Do we target an inexisting ressource, a folder, or a file?
if ($trgt == "") {
	// but first let's support some form of aliases (or "shortcuts")
	if (is_dir($dir)) {
		$trgt = "ok";
		if ($rights>=0 and file_exists($dir."/CSE_lock")) {
			$content = file_get_contents($dir."/CSE_lock");
			if (strstr($content, $rights) === false) {
				$title = $CSE_FORBIDDEN_TITLE[$lan];
				$content = $CSE_FORBIDDEN[$lan];
				$trgt = "CSE_null";
			}
		}
		if ($trgt == "ok") {
			$trgt = "folder";
			$title = str_replace("_", " ", $fld_list[count($fld_list)-1]);
			if (file_exists($dir."/CSE_translate")) {
				$translate_opt = file_get_contents($dir."/CSE_translate");
			}
			if (file_exists($dir."/CSE_content")) {
				$content_opt = file_get_contents($dir."/CSE_content");
			}
		}
		if ($rights < 0) {
			$title_nice = $title;
			$title .= "&nbsp;&nbsp;&nbsp;[<a href='".$delete_base_url.$edit_url."'>Delete</a>]";
		}
	} else {
		$trgt = "ok";
		array_pop($fld_list);
		if ($rights>=0 and file_exists($parentdir."/CSE_lock")) {
			$content = file_get_contents($parentdir."/CSE_lock");
			if (strstr($content, $rights) === false) {
				$title = $CSE_FORBIDDEN_TITLE[$lan];
				$content = $CSE_FORBIDDEN[$lan];
				$trgt = "CSE_null";
			}
		}
		if ($trgt == "ok") {
			if (file_exists($parentdir."/CSE_translate")) {
				$translate_opt = file_get_contents($parentdir."/CSE_translate");
			}
			if (file_exists($dir.".txt")) {
				$trgt = "file";
				$title = str_replace("_", " ", basename($dir));
				$content = file_get_contents($dir.".txt");
			} elseif (file_exists($dir.".htm")) {
				$trgt = "file";
				$title = str_replace("_", " ", basename($dir));
				$content = file_get_contents($dir.".htm");
			} elseif (file_exists($dir.".html")) {
				$trgt = "file";
				$title = str_replace("_", " ", basename($dir));
				$content = file_get_contents($dir.".html");
			} elseif (file_exists($dir)) {
				$trgt = "file";
				$title = str_replace("_", " ", basename($dir));
				$content = file_get_contents($dir);
			} else {
				$title = $CSE_WRONGLINK_TITLE[$lan];
				$content = $CSE_WRONGLINK[$lan];
				$trgt = "CSE_none";
			}
			if (substr($dir, strlen($dir)-5)==".ajax") {
				//$myHTML->addError("ajax");
				$myHTML->activateAJAX("http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/ajax/", "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/ajax/");
				$nb = preg_match("/.*\{\*([^\}]*)\*\}.*/",$content,$matches);
				if ($nb==1) {
					$function = "\$return = \$myHTML->ajaxIt(".$matches[1].");";
					eval($function);
				}
				$content = preg_replace("/.*\{\*([^\}]*)\*\}.*/",$return, $content);
				// $content .= "<br><b>".$function."</b> - ".$return;
			}
			// remove filetype, if any
			$nb = preg_match("/(.*)\.(.{2,5})$/",$title,$matches);
			if ($nb==1) {
				$title = $matches[1];
			}
			if ($rights < 0) {
				$title .= "&nbsp;&nbsp;&nbsp;[<a href='".$edit_base_url.$edit_url."'>Edit</a>]&nbsp;[<a href='".$delete_base_url.$edit_url."'>Delete</a>]";
			}
		}
	}
}

// Create logical structure
$lgs = "";
$all = opendir(dirname(__FILE__));
$folders = array();
$ini = false;
while ($file = readdir($all)) {
	if (is_dir(dirname(__FILE__)."/".$file) and $file <> ".." and $file <> ".") {
		if (isset($CSE_LANG[$file])) {
			if ($ini) {
				$lgs .="<span class=but_sep>&middot;</span>";
			}
			$nb = preg_match("/all: ([^\n]*)/i", $translate_opt, $matches);
			if ($nb == 1) {
				$tr_link = $_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$file."/".$matches[1];
			} else {
				$nb = preg_match("/".$file.": ([^\n]*)/i", $translate_opt, $matches);
				// $myHTML->AppendBody($translate_opt." "."/".$file.": (*.)/i -- ".($nb?$nb:"false")."<br>", 2);
				if ($nb == 1) {
					$tr_link = $_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$matches[1];
				} else {
					$tr_link = $_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$file;
				}
			}
			$lgs .= "<a class=tree href='http://".$tr_link."'><img title='".$CSE_LANG["$file"]."' alt='".$CSE_LANG["$file"]."' src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/".$file.".gif'></a>";
			$ini = true;
		}
	} else {
		
	}
}

// Search box
makeSearch($myHTML, $CSE_SEARCH, $CSE_IN_LANG, $CSE_WHOLE_SITE, $lan);
// Cool links
makeHotLinks($myHTML, $CSE_HOT, $lan, $master_url);
// Statistics
updateStats($myHTML,$CSE_STATS,$lan);
// Contacts
makeContacts($myHTML, $CSE_CONTACTS, $CSE_COMMENTS, $lan, $master_url);

makeTOC($myHTML, $CSE_TOC_NAME[$lan], $lan, $fld_list, $rights);
// if ($trgt == "folder") {
// 	makeCatTOC($myHTML, $CSE_CATTOC_NAME[$lan], $dir, $url);
// }
// if ($trgt == "file") {
// 	makeCatTOC($myHTML, $CSE_CATTOC_NAME[$lan], $parentdir, $parenturl);
// }

// The headers and footers
$myHTML->setCopyright($CSE_COPY[$lan]);
$myHTML->setTitle($CSE_SITE_HEADER[$lan]);

if ($title == "") {
	$title = $CSE_SITE_TITLE[$lan];
	$myHTML->appendRegion("MAINTITLE",$CSE_SITE_TITLE[$lan],1);
} else {
	$myHTML->appendRegion("MAINTITLE",$title." - ".$CSE_SITE_TITLE[$lan],1);
}
$myHTML->setBodyTitle($extra_title.$title);
$myHTML->setFooter("<table width='100%' border=0><tr><td width='80%'>".$path_string."</td><td align=right>".$lgs."</td></tr></table>");
$myHTML->setBlogReadMore($BLOG[$lan]);

if ($trgt == "file") {
	if (strpos($dir, ".embed")) {	
		//$myHTML->registerJSfunction("iFrameHeight()","var h = 0;\nif ( !document.all ) {\n h = document.getElementById('blockrandom').contentDocument.height;\n document.getElementById('blockrandom').style.height = h + 60 + 'px';\n} else if( document.all ) {\n h = document.frames('blockrandom').document.body.scrollHeight;\n document.all.blockrandom.style.height = h + 20 + 'px';\n}");
		$it_link = file_get_contents($dir);
		$content_opt = str_replace("\n", "", $it_link);
		parse_str($content_opt, $myContent);
		$myHTML->setBody("<iframe id=\"blockrandom\" name=\"iframe\" src=\"".$myContent['link']."\"width=\"100%\" height=\"500\" scrolling=\"auto\" align=\"top\" frameborder=\"0\" class=\"wrapper\">This option will not work correctly.  Unfortunately, your browser does not support Inline Frames</iframe>");
	} elseif (strpos($dir, ".exbed")) {	
		$myHTML->setCSS($master_url."/CSE_display/CSE_CSS_CMS_Exbed.css");
		$myHTML->setTemplate($master_url."/CSE_display/CSE_template_CMS_Exbed.txt");
		//$myHTML->registerJSfunction("iFrameHeight()","var h = 0;\nif ( !document.all ) {\n h = document.getElementById('blockrandom').contentDocument.height;\n document.getElementById('blockrandom').style.height = h + 60 + 'px';\n} else if( document.all ) {\n h = document.frames('blockrandom').document.body.scrollHeight;\n document.all.blockrandom.style.height = h + 20 + 'px';\n}");
		$it_link = file_get_contents($dir);
		$content_opt = str_replace("\n", "", $it_link);
		parse_str($content_opt, $myContent);
		$myHTML->setBody("<iframe id=\"blockrandom\" name=\"iframe\" src=\"".$myContent['link']."\"width=\"100%\"  height=\"800\" scrolling=\"auto\" align=\"top\" frameborder=\"0\" class=\"wrapper\">This option will not work correctly.  Unfortunately, your browser does not support Inline Frames</iframe><script>iFramHeight();</script>");
	} else {
		$myHTML->setBody($content);
	}
} elseif ($trgt == "folder") {
	//$myHTML->setBody($dir."/CSE_Gallery.txt: ".(file_exists($dir."/CSE_Gallery.txt")), 3);
	if (file_exists($dir."/CSE_Gallery.txt")) {
		$myHTML->registerGallery($dir,$title);
		// because we may have chapters:
		$myHTML->gallery->setImageRoot($url);
		$myHTML->gallery->setMainPage($url."/");
	} else {
		if ($content_opt == "") {
			$all = opendir($dir);
			while ($file = readdir($all)) {
				// first let deal with soft links (aliases)
				if (strpos($file, ".link")) {
					$blg_title = str_replace("_", " ", $file);
					$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
					if ($nb==1) {
						$blg_title = $matches[1];
					}
					$blg_date = date("d-m-Y", filemtime($dir."/".$file));
					$filelink = $master_url."/".file_get_contents($dir."/".$file);
					$lk_tp = file_get_contents($dir."/".$file);
					// does the link go to another language?
					$nb = preg_match("/^(..)\/.*$/",$lk_tp,$matches);
					if ($nb==1) {
						$new_lan = $matches[1];
						if ($new_lan == $lan) {
							$new_lan = "";
						} else {
							$new_lan = "<img title='".$CSE_LANG[$new_lan]."' alt='".$CSE_LANG[$new_lan]."' src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/".$new_lan.".gif' width=16>";
						}
					} else {
						$new_lan = "";
					}
					$newfile = dirname(__FILE__)."/".$lk_tp;
					if (is_dir($newfile)) {
						$blg_data = displayfolder($lan, $newfile, $filelink, "", $CSE_LANG); // $CSE_Content_Category[$lan].":<br>"
						$myHTML->registerBlogs("<i>".$blg_title."</i> ".$new_lan, $blg_data, 2, $blg_date, $filelink);
					} else {
						if (file_exists($newfile.".txt")) {
							$blg_data = file_get_contents($newfile.".txt");
							$blg_date = date("d-m-Y", filemtime($newfile.".txt"));
						} elseif (file_exists($dir.".htm")) {
							$blg_data = file_get_contents($newfile.".htm");
							$blg_date = date("d-m-Y", filemtime($newfile.".htm"));
						} elseif (file_exists($dir.".html")) {
							$blg_data = file_get_contents($newfile.".html");
							$blg_date = date("d-m-Y", filemtime($newfile.".html"));
						} elseif (file_exists($dir)) {
							$blg_data = file_get_contents($newfile);
							$blg_date = date("d-m-Y", filemtime($newfile));
						}
						$blg_data = substr($blg_data, 0, $CSE_CHAR_BLOG)."...";
						$blg_data = strip_tags($blg_data,'<br>');
						$myHTML->registerBlogs("<i>".$blg_title."</i> ".$new_lan, $blg_data, 1, $blg_date, $filelink);
					}
				} elseif (strpos($file, ".plug")) {
					$blg_title = str_replace("_", " ", $file);
					$nb = preg_match("/(.*)\.(.{4})$/",$blg_title,$matches);
					if ($nb==1) {
						$blg_title = $matches[1];
					}
					$blg_date = date("d-m-Y", filemtime($dir."/".$file));
					$it_link = file_get_contents($dir."/".$file);
					$content_opt = str_replace("\n", "", $it_link);
					parse_str($content_opt, $myContent);
					$myHTML->registerBlogs($blg_title, $myContent['text'], 1, $blg_date, $master_url."/".$lan."/CSE_plugin?name=".$myContent['name']);
				} elseif (strpos($file, ".embed")) {
					$blg_title = str_replace("_", " ", $file);
					$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
					if ($nb==1) {
						$blg_title = $matches[1];
					}
					$blg_date = date("d-m-Y", filemtime($dir."/".$file));
					$it_link = file_get_contents($dir."/".$file);
					$content_opt = str_replace("\n", "", $it_link);
					parse_str($content_opt, $myContent);
					$myHTML->registerBlogs($blg_title, "<i>".$CSE_embed[$lan]."</i><br>".$myContent['text'], 1, $blg_date, $url."/".$file);
				} elseif (strpos($file, ".exbed")) {
					$blg_title = str_replace("_", " ", $file);
					$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
					if ($nb==1) {
						$blg_title = $matches[1];
					}
					$blg_date = date("d-m-Y", filemtime($dir."/".$file));
					$it_link = file_get_contents($dir."/".$file);
					$content_opt = str_replace("\n", "", $it_link);
					parse_str($content_opt, $myContent);
					$myHTML->registerBlogs($blg_title, "<i>".$CSE_embed[$lan]."</i><br>".$myContent['text'], 1, $blg_date, $url."/".$file);
				} else {
					if ($file <> ".." and $file <> "." and (strpos($file, ".")!==0) and $file<>"CSE_lock" and $file<>"CSE_gallery.txt" and $file<>"CSE_translate" and $file<>"CSE_content" and $file<>"CSE_hot") {
						if (is_dir($dir."/".$file)) {
							$trgt = "ok";
							if ($rights>=0 and file_exists($dir."/".$file."/CSE_lock")) {
								$content = file_get_contents($dir."/".$file."/CSE_lock");
								if (strstr($content, $rights) === false) {
									$title = $CSE_FORBIDDEN_TITLE[$lan];
									$content = $CSE_FORBIDDEN[$lan];
									$trgt = "CSE_null";
								}
							}
							if ($trgt == "ok") {
								$blg_date = date("d-m-Y", filemtime($dir."/".$file));
// 								if (file_exists($dir."/".$file."/CSE_Gallery.txt")) {
// 									$blg_data = "<table><tr><td valign=top><a href=".$url."/".$file."><img src=http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/folder_icon.png></a></td><td valign=top>";
// 									$blg_data .= $CSE_Gallery_Category[$lan]."<br>";
// 									// try to find a thumbnail
// 									if (file_exists($dir."/".$file."/tn/")) {
// 										if (is_dir($dir."/".$file."/tn/")) {
// 											$suball = opendir($dir."/".$file."/tn/");
// 											$over = 0;
// 											while ($subfile = readdir($suball) and $over<2) {
// 												if (stripos($subfile, ".png") or stripos($subfile, ".jpg") or stripos($subfile, ".gif") or stripos($subfile, ".jpeg")) {
// 													$over++;
// 													$blg_data .= "<img src=".$url."/".$file."/tn/".$subfile.">";
// 												}
// 											}
// 										}
// 									}
// 									$blg_data .= "...</td></tr></table>";
// 									$myHTML->registerBlogs(str_replace("_", " ", $file), $blg_data, 2, $blg_date, $url."/".$file);
								//} else {								
									$blg_data = displayfolder($lan, $dir."/".$file, $file, "", $CSE_LANG); // $CSE_Content_Category[$lan].":<br>"
									$blg_date = date("d-m-Y", filemtime($dir."/".$file));
									$myHTML->registerBlogs(str_replace("_", " ", $file), $blg_data.$subcnt, 2, $blg_date, $url."/".$file);
								//}
							}
						} else {
							if (file_exists($dir.".txt")) {
								$blg_title = str_replace("_", " ", $file);
								$blg_data = file_get_contents($dir."/".$file.".txt");
								$blg_date = date("d-m-Y", filemtime($dir."/".$file.".txt"));
							} elseif (file_exists($dir.".htm")) {
								$blg_title = str_replace("_", " ", $file);
								$blg_data = file_get_contents($dir."/".$file.".htm");
								$blg_date = date("d-m-Y", filemtime($dir."/".$file.".htm"));
							} elseif (file_exists($dir.".html")) {
								$blg_title = str_replace("_", " ", $file);
								$blg_data = file_get_contents($dir."/".$file.".html");
								$blg_date = date("d-m-Y", filemtime($dir."/".$file.".html"));
							} elseif (file_exists($dir)) {
								$blg_title = str_replace("_", " ", $file);
								$blg_data = file_get_contents($dir."/".$file);
								$blg_date = date("d-m-Y", filemtime($dir."/".$file));
							}
							$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
							if ($nb==1) {
								$blg_title = $matches[1];
							}
							$blg_data = substr($blg_data, 0, $CSE_CHAR_BLOG)."...";
							$myHTML->registerBlogs($blg_title, (strip_tags($blg_data,'<br>')), 1, $blg_date, $url."/".$file."/");
						}
					}
				}
			}
		} else {
			// we have a $content_opt, so use it simply.
			$content_opt = str_replace("\n", "", $content_opt);
			parse_str($content_opt, $myContent);
			// set title
			$myHTML->setBodyTitle($myContent['Title']);
			// prepend on page
			$myHTML->prependBody("<div class=news_box>".$myContent['Prepend']."</div>");
			// append on page
			$myHTML->setBody("<div class=news_box>".$myContent['Append']."</div>",2);
			// go through the elements
			$i=0;
			while ($el_type = each($myContent['Element'])) {
				if ($el_type = "Blog") {
					$blg_len = $myContent['Option'][$i];
					$blg_title = str_replace("_", " ", $myContent['Name'][$i]);
					$file = $myContent['Name'][$i];
					if (strpos($file, ".link") and ($blg_len!=0)) {
						$blg_title = str_replace("_", " ", $file);
						$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
						if ($nb==1) {
							$blg_title = $matches[1];
						}
						$blg_date = date("d-m-Y", filemtime($dir."/".$file));
						$filelink = $master_url."/".file_get_contents($dir."/".$file);
						$lk_tp = file_get_contents($dir."/".$file);
						// does the link go to another language?
						$nb = preg_match("/^(..)\/.*$/",$lk_tp,$matches);
						if ($nb==1) {
							$new_lan = $matches[1];
							if ($new_lan == $lan) {
								$new_lan = "";
							} else {
								$new_lan = "<img title='".$CSE_LANG[$new_lan]."' alt='".$CSE_LANG[$new_lan]."' src='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/".$new_lan.".gif' width=16>";
							}
						} else {
							$new_lan = "";
						}
						$newfile = dirname(__FILE__)."/".$lk_tp;
						if (is_dir($newfile)) {
							$blg_data = displayfolder($lan, $newfile, $filelink, "", $CSE_LANG); // $CSE_Content_Category[$lan].":<br>"
							$myHTML->registerBlogs("<i>".$blg_title."</i> ".$new_lan, $blg_data, 2, $blg_date, $filelink);
						} else {
							if (file_exists($newfile.".txt")) {
								$blg_data = file_get_contents($newfile.".txt");
								$blg_date = date("d-m-Y", filemtime($newfile.".txt"));
							} elseif (file_exists($dir.".htm")) {
								$blg_data = file_get_contents($newfile.".htm");
								$blg_date = date("d-m-Y", filemtime($newfile.".htm"));
							} elseif (file_exists($dir.".html")) {
								$blg_data = file_get_contents($newfile.".html");
								$blg_date = date("d-m-Y", filemtime($newfile.".html"));
							} elseif (file_exists($dir)) {
								$blg_data = file_get_contents($newfile);
								$blg_date = date("d-m-Y", filemtime($newfile));
							}
							$blg_data = substr($blg_data, 0, $CSE_CHAR_BLOG)."...";
							$blg_data = strip_tags($blg_data,'<br>');
							$myHTML->registerBlogs("<i>".$blg_title."</i> ".$new_lan, $blg_data, 1, $blg_date, $filelink);
						}
					} else {
						$blg_data = file_get_contents($dir."/".$file);
						$blg_date = date("d-m-Y", filemtime($dir));
						$nb = preg_match("/(.*)\.(.{2,5})$/",$blg_title,$matches);
						if ($nb==1) {
							$blg_title = $matches[1];
						}
						if ($blg_len > 0) {
							$blg_data = substr($blg_data, 0, $blg_len)."...";
							$myHTML->registerBlogs($blg_title, (strip_tags($blg_data,'<p><a><br><ul><li><ol>')), $priority=0, $blg_date, $url."/".$myContent['Name'][$i]."/", $myContent['Author'][$i]);
						} elseif ($blg_len < 0) {
							$myHTML->registerBlogs($blg_title, (strip_tags($blg_data,'<p><a><br><ul><li><ol>')), $priority=0, $blg_date, $url."/".$myContent['Name'][$i]."/", $myContent['Author'][$i]);
						} else {
							$myHTML->registerBlogs($blg_title, $myContent['Text'][$i], $priority=0, $blg_date, $url."/".$myContent['Name'][$i]."/", $myContent['Author'][$i]);
						}
					}
				} else {
				
				}
				$i++;
			}
			
			//$myHTML->setBody(print_r($myContent));
		}
	}
} elseif ($trgt == "search") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_comment") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_plugin") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_admin") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_contact") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_addCat") {
	$flsrc = dirname(__FILE__)."/".$lan.$flsrc;
	if (file_exists($flsrc)) {
		$content = "<b>Folder '".$flsrc."' already exists!</b><br><br>";	
	} else {
		$ok = mkdir($flsrc);
		if ($ok) {
			$content = "<b>Folder '".$flsrc."' created successfully!</b><br><br>";
		} else {
			$content = "<b>Folder '".$flsrc."' creation failed...</b><br><br>";
		}
	}
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_delete") {
	$ed_cnt = "";
	if (is_dir($dir.$flsrc)) {
		if (cleaninput($_GET['confirm'])=="TRUE") {
			// first we must empty  the folder, by deleting all documents
			$all = opendir($dir.$flsrc);
			while ($file = readdir($all)) {
				if ($file <> ".." and $file <> ".") {	
					$ok=unlink($dir.$flsrc."/".$file);
					$ed_cnt = $dir.$flsrc."/".$file." deleted.<br>";
				}
			}
			$ok = rmdir($dir.$flsrc);
			$ed_cnt .= $dir.$flsrc."/".$file." deleted.<br>";
		} else {
			$ed_cnt .= "Please confirm deletion of the folder <b>and all its content!</b><br><br>";
			$ed_cnt .= "No backup copy will be made, you cannot undo the deletion!<br><br>";
			$ed_cnt .= "To confirm, click here: [<a href='".$delete_base_url.(cleaninput($_GET["src"]))."&confirm=TRUE'>Delete</a>]<br><br>";
			$ed_cnt .= "<br><i>Note: deleting folder with nested folders is not allowed. First delete nested folders seaparately if needed. However, even if there are nested folders, clicking on 'Delete' above may remove some documents!</i><br><br>";
		}
	} else {
		if (file_exists($dir.$flsrc)) {
			$nb = preg_match("/(.*)\/([^\/]*)$/", $flsrc, $matches);
			$flsrcn = $matches[1]."/.".$matches[2];
			$flsrcn2 = $matches[1]."/".(str_replace(" ", "_", cleaninput($_GET['ed_tit'])));
			$ok2 = true;
			$ok=copy($dir.$flsrc, $dir.$flsrcn);
			if ($ok===false) {
				$ed_cnt .= "<b>Copy to backup file failed!: ".$dir.$flsrcn."</b><br><br>";
				$ok2 = false;
			}
			$ok=unlink($dir.$flsrc);
			if ($ok === false) {
				$ed_cnt .= "<b>Deleting old file failed!: ".$dir.$flsrc."</b><br><br>";
				$ok2 = false;
			}
			if ($ok2) {
				$ed_cnt .= "<b>Document deleted. A backup copy (".$dir.$flsrcn.") has been saved!</b><br><br><hr><br>";
			}
			$ed_cnt .= file_get_contents($dir.$flsrcn2);
		} else {
			$ed_cnt .= "<b>File not found: ".$dir.$flsrc."</b>.<br><br>";
		}
	}
	$myHTML->setBody($ed_cnt);
} elseif ($trgt == "CSE_save") {
	$ed_cnt = "";
	if (file_exists($dir.$flsrc)) {
		$nb = preg_match("/(.*)\/([^\/]*)$/", $flsrc, $matches);
		$flsrcn = $matches[1]."/.".$matches[2];
		$flsrcn2 = $matches[1]."/".(str_replace(" ", "_", cleaninput($_POST['ed_tit'])));
		$ok2 = true;
		$ok=copy($dir.$flsrc, $dir.$flsrcn);
		if ($ok===false) {
			$ed_cnt .= "<b>Copy to backup file failed!: ".$dir.$flsrcn."</b><br><br>";
			$ok2 = false;
		}
		$ok=unlink($dir.$flsrc);
		if ($ok === false) {
			$ed_cnt .= "<b>Deleting old file failed!: ".$dir.$flsrc."</b><br><br>";
			$ok2 = false;
		}
		$ok=file_put_contents($dir.$flsrcn2, cleaninput($_POST['ed_cnt']));
		if ($ok===false) {
			$ed_cnt .= "<b>Writing file failed!: ".$dir.$flsrcn2."</b><br><br>";
			$ok2 = false;
		}
		if ($ok2) {
			$ed_cnt .= "<b>Document update OK! A backup copy of the old version (".$dir.$flsrcn.") has been saved!</b><br><br><hr><br>";
		}
		$ed_cnt .= file_get_contents($dir.$flsrcn2);
	} else {
		$ed_cnt .= "<b>File not found: ".$dir.$flsrc."</b>. Adding it...<br><br>";
		$nb = preg_match("/(.*)\/([^\/]*)$/", $flsrc, $matches);
		$flsrcn2 = $matches[1]."/".(str_replace(" ", "_", cleaninput($_POST['ed_tit'])));
		$ok2 = true;
		$ok=file_put_contents($dir.$flsrcn2, cleaninput($_POST['ed_cnt']));
		if ($ok===false) {
			$ed_cnt .= "<b>Writing file failed!: ".$dir.$flsrcn2."</b><br><br>";
			$ok2 = false;
		}
		if ($ok2) {
			$ed_cnt .= "<b>Document creation OK!</b><br><br><hr><br>";
		}
		$ed_cnt .= file_get_contents($dir.$flsrcn2);
	}
	
	$myHTML->setBody($ed_cnt);
	
} elseif ($trgt == "CSE_uploadData") {
	// $title = "Trying to upload to: ".$flsrc;
	if ($_FILES['upfile']['error'] == 0) {
		$filename = $flsrc.$_FILES['upfile']['name'];
		if (move_uploaded_file($_FILES['upfile']['tmp_name'], $filename)) {
			$myHTML->setBody("Yeah - looks successful...");
		} else {
			$myHTML->setBody("Some problems happened... ".$_FILES['upfile']['error']);
		}
	}
} elseif ($trgt == "CSE_index") {
	$myHTML->setBody($content);
} elseif ($trgt == "CSE_edit") {
	$myHTML->addExternalJS("http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/widgEditor_1/scripts/widgEditor.js"); // rtwedit.js
	//$myHTML->registerJSonLoad("addHtmlEditor();");
	if (file_exists($dir.$flsrc)) {
		$ed_tit = str_replace("_", " ", basename($dir.$flsrc));
		$ed_cnt = file_get_contents($dir.$flsrc);
	}
	$editform = "<form action='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/".$lan."/CSE_save/' method=post><table><tr><td>Title:</td><td><input type=text name=ed_tit id=ed_tit value='".$ed_tit."'></td></tr>";
	$editform .= "<tr><td valign=top>Content:</td><td><textarea rows=20 cols=80 id=ed_cnt name=ed_cnt class='widgEditor nothing'>".$ed_cnt."</textarea></td></tr>";
	$editform .= "<tr><td align=right colspan=2><input type=submit name=submit value=save><input type=hidden id=src name=src value='".(str_replace("/", "£", $flsrc))."'></td></tr>";
	$editform .= "</table></form>";
	$myHTML->setBody($editform);
	//$myHTML->appendBody($dir.$flsrc, 2);
} elseif ($trgt == "CSE_none") {
	$myHTML->setBody($CSE_WRONGLINK[$lan]);
} elseif ($trgt == "CSE_null") {
	$myHTML->setBody($content);
}


// $myHTML->appendBody("<hr>GET: ".print_r($_GET, true)."<br><br>");
// $myHTML->appendBody("<hr>POST: ".print_r($_POST, true)."<br><br>");
// $myHTML->appendBody("<hr>FILES: ".print_r($_FILES, true)."<br><br>");

// $myHTML->appendBody("<hr>".print_r($_GET, true)."<br><br>".dirname(__FILE__)."<br><br>".$dir." (".$trgt.")<br><br>"."http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."<br><br>".$url,2);
// 
// // test links
// $link = "/eng/cat/sub1/blop";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/eng/cat/sub1/blop?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/cat/sub1/sub2/sub3/rest?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/cat/sub1/sub2/sub3?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/cat/sub1/sub2?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/cat/sub1?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/Category1?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en/cat?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en?abdul=arhamlid&albert=demonaco";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// $link = "/en";
// $myHTML->appendBody("<br><a href='http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."'>http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).$link."</a>",3);
// 
// // test regexp
// $pattern = "@(.*)/([^/]*)$@";
// $string = "/Volumes/Data/Users/Cavin/Sites/Cms/En/Category1";
// preg_match($pattern,$string,$matches);
// $myHTML->appendBody("<br><br>String: ".$string." - pattern: ".$pattern."<br>preg_split: ".print_r(preg_split($pattern,$string), true)."<br>preg_match_all: ".print_r(preg_match_all($pattern,$string), true)."<br>preg_match (with hits): ".print_r($matches, true), 4);
	
	
// correct some directories
$myHTML->IP_setMainPage($url);
$myHTML->IP_setImageRoot("http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/CSE_display/imazes/");
$myHTML->IP_setPrefAll(5,1);
// Dump
$myHTML->dump();

?>